dames(N,L):- 
	length(L,N), 
	domain(L,1,N), 
	all_different(L), 
	noesmengen(L,1), 
	labeling([],L).

noesmengen([],_).
noesmengen([X|XS],N):- 
	M is N+1, 
	diagonals((X,N),(XS,M)), 
	noesmengen(XS,M).

diagonals(_,([],_)).
diagonals((X,N),([Y|Ys],M)):- 
	A #= X-Y, 
	B #= Y-X, 
	C is N-M,
	A #\= C,
	B #\= C,
	M2 is M+1,
	diagonals((X,N),(Ys,M2)).